/*!
 * @file    	main.c
 * @brief	 	Main program body
 *
 * @details		
 *
 * @version		V1.0.0
 * @author  	
 * @date    	2019-9-3
 *
 */

#include "apm32f10x.h"
#include "apm32f10x_usart.h"
#include "apm32_mini.h"
#include <stdio.h>
#include "stdarg.h"
#include "misc.h"
/*!
 * @brief		Main program
 *
 * @param		None
 *
 * @retval		None
 *
 * @see 
 *
 * @note 
 */
int main(void)
{ 
  /* USARTx configured as follow:
        - BaudRate = 115200 baud  
        - Word Length = 8 Bits
        - One Stop Bit
        - No parity
        - Hardware flow control disabled (RTS and CTS signals)
        - Receive and transmit enabled
  */	
	USART_ConfigStruct_T USART_ConfigStruct;
	
	USART_StructInit(&USART_ConfigStruct);
	USART_ConfigStruct.baudRate = 115200;
	
	APM_MINI_COMInit(COM1, &USART_ConfigStruct);
	
	USART_EnableInterrupt(USART1, USART_INT_RXNE);

	NVIC_EnableIRQRequest(USART1_IRQn, 1, 0);

	/* Output a message on Hyperterminal using printf function */
	printf("\n\rUSART Receive Interruption Example: Please send data\n\r");

	while (1)
	{

	}
}

#ifdef __GNUC__
#define PUTCHAR_PROTOTYPE int _io_putchar(int ch)
#else
#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif

/*!
 * @brief		Retargets the C library printf function to the USART
 *
 * @param		None
 *
 * @retval		None
 *
 * @see 
 *
 * @note 
 */
PUTCHAR_PROTOTYPE
{
	/* Loop until the end of transmission */
	while (USART_ReadFlag(APM32_MINI_COM1, USART_FLAG_TXBE) == RESET);
	
	USART_TxData(APM32_MINI_COM1, (uint8_t)ch);
	
	return ch;
}
